; GUI #
include win64a.inc
cdXPos          = 128
cdYPos          = 128
cdXSize         = 320
cdYSize         = 220
SmoothingModeInvalid = 0
SmoothingModeDefault = 1
SmoothingModeHighSpeed = 2
SmoothingModeHighQuality = 3
SmoothingModeNone = 4
SmoothingModeAntiAlias = 5
SmoothingModeAntiAlias8x4 = 6
SmoothingModeAntiAlias8x8 = 7
.code
WinMain proc 
local	msg:MSG
           
;  GDIPLUS
	invoke GdiplusStartup,&gdiplusToken,&gsi,0	
	xor ebx,ebx
	mov esi,IMAGE_BASE
	invoke	LoadCursorFromFileA,&FileName
	mov	edi,offset ClassName
	push	rax	   ;hIconSm
	push	rdi	   ;lpszClassName
	push	rbx	   ;lpszMenuName
	push	COLOR_BTNFACE;hbrBackground
	push	rax	   ;hCursor
	push	rax       ;hIcon
	push	rsi	   ;hInstance
	push	rbx       ;cbClsExtra & cbWndExtra
	pushaddr WndProc     ;lpfnWndProc
      	push sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX
	push	rbx
	push	rsi	;rsi=400000h
	push	rbx
	push	rbx
	push	cdYSize
	push	cdXSize
	push	cdYPos
	push	cdXPos
	sub	esp,20h
    	invoke	CreateWindowExA,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
    	lea edi,msg
@@:   	invoke	GetMessageA,edi,NULL,0,0
	invoke	DispatchMessageA,edi
        jmp @b
WinMain endp
WndProc proc hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	hdc:HDC          ;
local	ps:PAINTSTRUCT
local	hGraphics:qword
local	hBrush:qword

      	mov	hWnd,rcx
      	cmp	edx,WM_DESTROY
      	je	wmDESTROY
      	cmp	edx,WM_PAINT
      	je	wmPAINT
      	cmp	edx,WM_SIZE
      	je	wmSIZE
      	cmp	edx,WM_KEYDOWN
	je	wmKEYDOWN
        leave
        jmp NtdllDefWindowProc_

wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	jne	wmBYE

wmDESTROY:mov	ecx,gdiplusToken
	invoke	GdiplusShutdown
	invoke	RtlExitUserProcess,NULL
;------------------------------------------------------------
wmSIZE: mov	vdxClient,r9d
	and	vdxClient,0FFFFh;vdxClient = LOWORD (lParam)
	shr	r9d,16
	mov	vdyClient,r9d;vdyClient = HIWORD (lParam) ;
	invoke	InvalidateRect,hWnd, NULL, TRUE	
	jmp	wmBYE
wmPAINT:invoke	BeginPaint,hWnd, &ps
	mov	hdc,rax
	invoke	GdipCreateFromHDC,eax,&graphics
	invoke	GdipSetSmoothingMode,graphics, SmoothingModeAntiAlias;    
;          
	invoke	GdipCreateSolidFill,0FF0000FFh,&hBrush
	xor	edi,edi
@@:	cvtsi2ss xmm1,edi
	invoke	GdipRotateWorldTransform,graphics,, 1
	cvtsi2ss xmm1,vdxClient
	divss	xmm1,const2; (float)vdxClient/2.0
	cvtsi2ss xmm2,vdyClient
	divss	xmm2,const2;(float)vdyClient/2.0
	invoke	GdipTranslateWorldTransform,graphics,,,1
	mov	r8d,10
	mov	[rsp+28h],r8
	mov	qword ptr[rsp+20h], 70
	invoke	GdipFillRectangleI,graphics, hBrush,,10;   
	invoke	GdipResetWorldTransform,graphics
	add	edi,40
	cmp	edi,360
	jb	@b
	invoke	GdipDeleteBrush,hBrush
	invoke	GdipDeleteGraphics,graphics
	invoke	EndPaint,hWnd, &ps
wmBYE:  leave
        ret
WndProc endp
;---------------------------------------
.data
ClassName db '  GDI+',0
FileName db "br_Rabbit3.cur",0
gsi GdiplusStartupInput <1,0,0,0,0>
const2		dd 2.0
.data?
gdiplusToken	dd ?
graphics	dq ?
vdxClient	dd ?
vdyClient	dd ?
end